//                                         This file is really -*-C++/l-*-
//        Directory:  Homework/Assignment1/Solutions/Code/FSM/
//             File:  AbstractFiniteStateMachine.cpp
//       Created by:  David Casperson <casper@David-Caspersons-Computer.local>
//          Created:  Sat Oct  6 17:11:01 2007
//
//      Description:  Implementation of the non-virtual parts of the
//                    AbstractFiniteStateMachine


#include "AbstractFiniteStateMachine.h"


template <class State, class char_t>
void
AbstractFiniteStateMachine<State, char_t>::
gotoState(char_t const& aChar)
{
    gotoState(nextState(currentState(), aChar)) ;
}


template <class State, class char_t>
void
AbstractFiniteStateMachine<State, char_t>::
gotoState(std::basic_string<char_t> const& str)
{
    for(int i=0,n=str.length(); i<n && !currentStateIsError(); ++i)
        gotoState(str[i]) ;
}

template <class State, class char_t>
bool 
AbstractFiniteStateMachine<State, char_t>::
accepts(std::basic_string<char_t> const& str)
{
    gotoState(startState()) ;
    gotoState(str) ;
    return !currentStateIsError() && currentStateIsAccepting() ;
}

