//  This file is really -*-C++/l-*-
//        Directory:  Homework/Assignment1/Solutions/Code/FSM/
//             File:  AbstractFiniteStateMachine.h
//       Created by:  David Casperson
//          Created:  Sat Oct  6 17:08:10 2007
//
//      Description:  An Finite State Machine Abstraction.


#if !defined(AbstractFiniteStateMachine_INCLUDED)
#include <string>


template <class State, class char_t>
class AbstractFiniteStateMachine
{
public:
    virtual ~AbstractFiniteStateMachine () {} 
    
    bool accepts(std::basic_string<char_t> const& str) ;
    
    // attributes of the FSM
    virtual State startState              ()                      const = 0 ;
    virtual State nextState               (const State&, char_t)  const = 0 ;
    virtual State currentState            ()                      const = 0 ;
    virtual bool  currentStateIsError     ()                      const = 0 ;
    virtual bool  currentStateIsAccepting ()                      const = 0 ;
    
    // behaviors of the FSM
    virtual void  gotoState               (State const&)                = 0 ;
    virtual void  gotoState               (char_t const&)                   ;
    virtual void  gotoState               (std::basic_string<char_t> const&);
    
private:
} ;// end class AbstractFiniteStateMachine


#define AbstractFiniteStateMachine_INCLUDED
    // upside down inclusions for c++ compilers that don't support
    // templates properly.  We put the #include guard before the include
    // so that AbstractFiniteStateMachine.cpp can be written to #include
    // this file.
#include "AbstractFiniteStateMachine.cpp"


#endif// !defined(AbstractFiniteStateMachine_INCLUDED)
