//                                         This file is really -*-C++/l-*-
//        Directory:  Homework/Assignment1/Solutions/Code/FSM/
//             File:  MapleFiniteStateMachine.cpp
//       Created by:  David Casperson <casper@David-Caspersons-Computer.local>
//          Created:  Sat Oct  6 20:22:51 2007
//
//      Description:  Implementation of the machine that recognizes
//                    maple floating point literal tokens.


#include "AbstractFiniteStateMachine.h"
#include "MapleFiniteStateMachine.h"

MapleTokenStates
MapleFloatTokenFiniteStateMachine::startState() const
{
    return Start ;
}

MapleTokenStates
MapleFloatTokenFiniteStateMachine::
nextState(MapleTokenStates const& oneState, char aChar) const
{
    char_classifier_t::mapped_type aClass(myCharClasses[aChar]) ;
    next_state_map_t::key_type myKey(std::make_pair(oneState, aClass)) ;
    next_state_map_t::const_iterator where2(myNextStateMap.find(myKey)) ;
    return
        (where2!=myNextStateMap.end()) ? where2->second : Error ;
}


MapleTokenStates
MapleFloatTokenFiniteStateMachine::currentState () const
{
    return myCurrentState ;
}

bool MapleFloatTokenFiniteStateMachine::currentStateIsError() const
{
    return myCurrentState == Error ;
}

bool
MapleFloatTokenFiniteStateMachine::
currentStateIsAccepting () const
{
    switch (myCurrentState)
        {
        case Point:
        case Fraction:
        case ExponentDigits:
        case TrailingWhiteSpace:
            return true ;
        default:
            return false ;
        }
}


void
MapleFloatTokenFiniteStateMachine::
gotoState (MapleTokenStates const& aState) 
{
    myCurrentState = aState ;
    return ;
}

MapleFloatTokenFiniteStateMachine::
MapleFloatTokenFiniteStateMachine(
    char_classifier_t const & charClasses,
    next_state_map_t  const & nextStateMap)
    : myCharClasses(charClasses)
    , myNextStateMap(nextStateMap)
    , myCurrentState(Start)
{}

MapleFloatTokenFiniteStateMachine::
~MapleFloatTokenFiniteStateMachine()
{}

