//                                         This file is really -*-C++/l-*-
//        Directory:  Assignment1/Solutions/Code/FSM/
//             File:  MapleFiniteStateMachine.h
//       Created by:  David Casperson <casper@David-Caspersons-Computer.local>
//          Created:  Sat Oct  6 19:20:30 2007
//
//      Description:  Finite State Machine with specific goal of
//                    recognizing maple floating point literal tokens.


#if !defined(MapleFiniteStateMachine_INCLUDED)
#include "AbstractFiniteStateMachine.h"
#include "MapleTypes.h"



class MapleFloatTokenFiniteStateMachine
    : public AbstractFiniteStateMachine<MapleTokenStates, char>
{
public:
    typedef CharClassMap char_classifier_t ;
    typedef 
    std::map<std::pair<MapleTokenStates,MapleTokenCharacterClasses>, MapleTokenStates> next_state_map_t ;

    MapleFloatTokenFiniteStateMachine(
        char_classifier_t const & charClasses,
            next_state_map_t  const & nextStateMap) ;
    ~MapleFloatTokenFiniteStateMachine() ;

    // attributes of the FSM
    virtual MapleTokenStates startState() const ;
    virtual MapleTokenStates nextState(const MapleTokenStates&, char) const ;
    virtual MapleTokenStates currentState() const ;

    virtual bool currentStateIsError() const ;
    virtual bool currentStateIsAccepting () const ;

    virtual void gotoState(MapleTokenStates const&) ;

private:
    char_classifier_t myCharClasses ;
    next_state_map_t myNextStateMap ;
    MapleTokenStates myCurrentState ;
} ;

#define MapleFiniteStateMachine_INCLUDED
#endif// !defined(MapleFiniteStateMachine_INCLUDED)
