//                                         This file is really -*-C++/l-*-
//        Directory:  Homework/Assignment1/Solutions/Code/FSM/
//             File:  MapleTypes.cpp
//       Created by:  David Casperson <casper@David-Caspersons-Computer.local>
//          Created:  Sat Oct  6 20:09:44 2007
//
//      Description:  Implementation of functions that produce maps that
//                    are used to create the MapleFiniteStateMachine object
//                    in the driver function.


#include "MapleTypes.h"

CharClassMap computeInitialMapleTokenCharacterClasses()
{
    struct InitData {
        char const * const string1 ;
        MapleTokenCharacterClasses class1 ;
    } ;

    struct InitData initData[] =
    {
        { " \t\n", WhiteSpaceCharacter},
        { "+-", SignCharacter},
        { ".", PointCharacter },
        { "0123456789", DigitCharacter},
        { "eE", ExponentCharacter}
    } ;

    unsigned int const initDataSize = sizeof(initData) / sizeof(initData[0]) ;

    CharClassMap myMap ;
    for(int i=0;i<initDataSize;++i)
        {
        std::string const chars(initData[i].string1) ;
        typedef std::string::const_iterator citer_t ;
        for(citer_t b=chars.begin(),e=chars.end();b!=e;++b)
            {
            myMap[*b] = initData[i].class1 ;
            }
        }
    return myMap ;
}

MapleNextMap computeInitialMapleTokenNextMap()
{
    struct InitData {
        MapleTokenStates state1;
        MapleTokenCharacterClasses charClass1 ;
        MapleTokenStates state2 ;
    } ;

    struct InitData initData[] =
    {
        { Start, WhiteSpaceCharacter, Start },
        { Start, SignCharacter, LeadingOptionalSign },
        { Start, PointCharacter, LeadingPoint },
        { Start, DigitCharacter, Mantissa },

        { LeadingPoint, DigitCharacter, Fraction },

        { LeadingOptionalSign, PointCharacter, LeadingPoint },
        { LeadingOptionalSign, DigitCharacter, Mantissa },

        { Mantissa, DigitCharacter, Mantissa },
        { Mantissa, ExponentCharacter, ExponentSymbol },
        { Mantissa, PointCharacter, Point },

        { Point, DigitCharacter, Fraction },
        { Point, ExponentCharacter, ExponentSymbol },

        { Fraction, DigitCharacter, Fraction },
        { Fraction, ExponentCharacter, ExponentSymbol },

        { ExponentSymbol, DigitCharacter, ExponentDigits },
        { ExponentSymbol, SignCharacter, ExponentSign },

        { ExponentSign, DigitCharacter, ExponentDigits },

        { ExponentDigits, DigitCharacter, ExponentDigits },
        { ExponentDigits, WhiteSpaceCharacter, TrailingWhiteSpace },

        { TrailingWhiteSpace, WhiteSpaceCharacter, TrailingWhiteSpace }
    } ;

    unsigned int const initDataSize = sizeof(initData) / sizeof(initData[0]) ;

    MapleNextMap myMap ;

    for(int i=0; i<initDataSize;++i)
        {
        myMap[std::make_pair(
                initData[i].state1,
                initData[i].charClass1)]
            = initData[i].state2 ;
        }

    return myMap ;
}
