//      This file is really -*-C++/l-*-
//        Directory:  Homework/Assignment1/Solutions/Code/FSM/
//             File:  MapleTypes.h
//       Created by:  David Casperson
//          Created:  Sat Oct  6 19:22:46 2007
//
//      Description:  Explicit enums that define the kinds of characters
//                    that one sees in Maple floating point literal
//                    tokens and the states found in the FSM that
//                    recognizes them.


#if !defined(MapleTypes_INCLUDED)
#include "MapWithDefault.h"

typedef enum {
    Error,
    Start,
    LeadingOptionalSign,
    LeadingPoint,
    Mantissa,
    Point,
    Fraction,
    ExponentSymbol,
    ExponentSign,
    ExponentDigits,
    TrailingWhiteSpace
}  MapleTokenStates ;

typedef 
enum  {
    OtherCharacter,
    WhiteSpaceCharacter,
    SignCharacter,
    PointCharacter,
    DigitCharacter,
    ExponentCharacter
} MapleTokenCharacterClasses ;

typedef MapWithDefault<char, MapleTokenCharacterClasses, OtherCharacter>
CharClassMap ;

typedef MapWithDefault<
    std::pair<MapleTokenStates, MapleTokenCharacterClasses>,
    MapleTokenStates, Error>
MapleNextMap ;


CharClassMap    computeInitialMapleTokenCharacterClasses () ;
MapleNextMap    computeInitialMapleTokenNextMap          () ;


#define MapleTypes_INCLUDED
#endif// !defined(MapleTypes_INCLUDED)
